#ifndef _DECL_WSLB_H_
#define _DECL_WSLB_H_
#include "charm++.h"
#include "LBDatabase.decl.h"

#include "BaseLB.decl.h"

/* DECLS: message WSLBStatsMsg;
 */
class WSLBStatsMsg;
class CMessage_WSLBStatsMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t,void*p) { return p; }
    void* operator new(size_t,const int);
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p,void*){CkFreeMsg(p);}
    void operator delete(void*p,const int){CkFreeMsg(p);}
    void operator delete(void*p){ CkFreeMsg(p);}
    void operator delete(void*p,int*,const int){CkFreeMsg(p);}
    void operator delete(void*p,int*){CkFreeMsg(p);}
#endif
    void operator delete(void*p,size_t){CkFreeMsg(p);}
    static void* alloc(int,size_t,int*,int);
    CMessage_WSLBStatsMsg() {};
    static void *pack(WSLBStatsMsg *p);
    static WSLBStatsMsg* unpack(void* p);
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, size);
    }
};


/* DECLS: group WSLB: BaseLB{
WSLB(CkMigrateMessage* impl_msg);
void WSLB(const CkLBOptions &impl_noname_0);
void ReceiveStats(WSLBStatsMsg* impl_msg);
void ResumeClients(void);
void ReceiveMigration(LBMigrateMsg* impl_msg);
};
 */
 class WSLB;
 class CkIndex_WSLB;
 class CProxy_WSLB;
 class CProxyElement_WSLB;
/* --------------- index object ------------------ */
class CkIndex_WSLB{
  public:
    typedef WSLB local_t;
    typedef CkIndex_WSLB index_t;
    typedef CProxy_WSLB proxy_t;
    typedef CProxyElement_WSLB element_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: WSLB(CkMigrateMessage* impl_msg);
 */
    static int __idx_WSLB_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_WSLB_CkMigrateMessage; }
    static void _call_WSLB_CkMigrateMessage(void* impl_msg,WSLB* impl_obj);

/* DECLS: void WSLB(const CkLBOptions &impl_noname_0);
 */
    static int __idx_WSLB_marshall1;
    static int ckNew(const CkLBOptions &impl_noname_0) { return __idx_WSLB_marshall1; }
    static void _call_WSLB_marshall1(void* impl_msg,WSLB* impl_obj);
    static int _callmarshall_WSLB_marshall1(char* impl_buf,WSLB* impl_obj);
    static void _marshallmessagepup_WSLB_marshall1(PUP::er &p,void *msg);

/* DECLS: void ReceiveStats(WSLBStatsMsg* impl_msg);
 */
    static int __idx_ReceiveStats_WSLBStatsMsg;
    static int ReceiveStats(WSLBStatsMsg* impl_msg) { return __idx_ReceiveStats_WSLBStatsMsg; }
    static void _call_ReceiveStats_WSLBStatsMsg(void* impl_msg,WSLB* impl_obj);

/* DECLS: void ResumeClients(void);
 */
    static int __idx_ResumeClients_void;
    static int ResumeClients(void) { return __idx_ResumeClients_void; }
    static void _call_ResumeClients_void(void* impl_msg,WSLB* impl_obj);

/* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
 */
    static int __idx_ReceiveMigration_LBMigrateMsg;
    static int ReceiveMigration(LBMigrateMsg* impl_msg) { return __idx_ReceiveMigration_LBMigrateMsg; }
    static void _call_ReceiveMigration_LBMigrateMsg(void* impl_msg,WSLB* impl_obj);
};
/* --------------- element proxy ------------------ */
class CProxyElement_WSLB: public CProxyElement_BaseLB{
  public:
    typedef WSLB local_t;
    typedef CkIndex_WSLB index_t;
    typedef CProxy_WSLB proxy_t;
    typedef CProxyElement_WSLB element_t;

    CProxyElement_WSLB(void) {}
    CProxyElement_WSLB(const IrrGroup *g) : CProxyElement_BaseLB(g){  }
    CProxyElement_WSLB(CkGroupID _gid,int _onPE,CkGroupID dTo) : CProxyElement_BaseLB(_gid,_onPE,dTo){  }
    CProxyElement_WSLB(CkGroupID _gid,int _onPE) : CProxyElement_BaseLB(_gid,_onPE){  }
   CK_DISAMBIG_GROUP_ELEMENT(CProxyElement_BaseLB)
    void ckDelegate(CkDelegateMgr *to) {
      CProxyElement_BaseLB::ckDelegate(to);
    }
    void ckUndelegate(void) {
      CProxyElement_BaseLB::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_BaseLB::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxyElement_BaseLB::ckSetGroupID(g);
    }
    WSLB* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static WSLB* ckLocalBranch(CkGroupID gID) {
      return (WSLB*)CkLocalBranch(gID);
    }
/* DECLS: WSLB(CkMigrateMessage* impl_msg);
 */

/* DECLS: void WSLB(const CkLBOptions &impl_noname_0);
 */

/* DECLS: void ReceiveStats(WSLBStatsMsg* impl_msg);
 */
    void ReceiveStats(WSLBStatsMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_WSLB::__idx_ReceiveStats_WSLBStatsMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(CkIndex_WSLB::__idx_ReceiveStats_WSLBStatsMsg, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_WSLB::__idx_ReceiveStats_WSLBStatsMsg, impl_msg, ckGetGroupPe(), ckGetGroupID());
    }

/* DECLS: void ResumeClients(void);
 */
    void ResumeClients(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_WSLB::__idx_ResumeClients_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(CkIndex_WSLB::__idx_ResumeClients_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_WSLB::__idx_ResumeClients_void, impl_msg, ckGetGroupPe(), ckGetGroupID());
    }

/* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
 */
    void ReceiveMigration(LBMigrateMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_WSLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupSend(CkIndex_WSLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupPe(), ckGetGroupID());
      } else CkSendMsgBranch(CkIndex_WSLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupPe(), ckGetGroupID());
    }
};
PUPmarshall(CProxyElement_WSLB);
/* ---------------- collective proxy -------------- */
class CProxy_WSLB: public CProxy_BaseLB{
  public:
    typedef WSLB local_t;
    typedef CkIndex_WSLB index_t;
    typedef CProxy_WSLB proxy_t;
    typedef CProxyElement_WSLB element_t;

    CProxy_WSLB(void) {}
    CProxy_WSLB(const IrrGroup *g) : CProxy_BaseLB(g){  }
    CProxy_WSLB(CkGroupID _gid,CkGroupID dTo) : CProxy_BaseLB(_gid,dTo){  }
    CProxy_WSLB(CkGroupID _gid) : CProxy_BaseLB(_gid){  }
    CProxyElement_WSLB operator[](int onPE) const
      {return CProxyElement_WSLB(ckGetGroupID(),onPE,ckDelegatedIdx());}
   CK_DISAMBIG_GROUP(CProxy_BaseLB)
    void ckDelegate(CkDelegateMgr *to) {
      CProxy_BaseLB::ckDelegate(to);
    }
    void ckUndelegate(void) {
      CProxy_BaseLB::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_BaseLB::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxy_BaseLB::ckSetGroupID(g);
    }
    WSLB* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static WSLB* ckLocalBranch(CkGroupID gID) {
      return (WSLB*)CkLocalBranch(gID);
    }
/* DECLS: WSLB(CkMigrateMessage* impl_msg);
 */

/* DECLS: void WSLB(const CkLBOptions &impl_noname_0);
 */
    static CkGroupID ckNew(const CkLBOptions &impl_noname_0, const CkEntryOptions *impl_e_opts=NULL);
    CProxy_WSLB(const CkLBOptions &impl_noname_0, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void ReceiveStats(WSLBStatsMsg* impl_msg);
 */
    void ReceiveStats(WSLBStatsMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_WSLB::__idx_ReceiveStats_WSLBStatsMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(CkIndex_WSLB::__idx_ReceiveStats_WSLBStatsMsg, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_WSLB::__idx_ReceiveStats_WSLBStatsMsg, impl_msg, ckGetGroupID());
    }
    void ReceiveStats(WSLBStatsMsg* impl_msg, int npes, int *pes)
    {
      CkSendMsgBranchMulti(CkIndex_WSLB::__idx_ReceiveStats_WSLBStatsMsg, impl_msg, npes, pes, ckGetGroupID());
    }

/* DECLS: void ResumeClients(void);
 */
    void ResumeClients(void)
    {
    ckCheck();
  void *impl_msg = CkAllocSysMsg();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_WSLB::__idx_ResumeClients_void, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(CkIndex_WSLB::__idx_ResumeClients_void, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_WSLB::__idx_ResumeClients_void, impl_msg, ckGetGroupID());
    }
    void ResumeClients(int npes, int *pes)
    {
  void *impl_msg = CkAllocSysMsg();
      CkSendMsgBranchMulti(CkIndex_WSLB::__idx_ResumeClients_void, impl_msg, npes, pes, ckGetGroupID());
    }

/* DECLS: void ReceiveMigration(LBMigrateMsg* impl_msg);
 */
    void ReceiveMigration(LBMigrateMsg* impl_msg)
    {
    ckCheck();
      if (ckIsDelegated()) {
         CkGroupMsgPrep(CkIndex_WSLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupID());
         ckDelegatedTo()->GroupBroadcast(CkIndex_WSLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupID());
      } else CkBroadcastMsgBranch(CkIndex_WSLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, ckGetGroupID());
    }
    void ReceiveMigration(LBMigrateMsg* impl_msg, int npes, int *pes)
    {
      CkSendMsgBranchMulti(CkIndex_WSLB::__idx_ReceiveMigration_LBMigrateMsg, impl_msg, npes, pes, ckGetGroupID());
    }
};
PUPmarshall(CProxy_WSLB);
typedef CBaseT<BaseLB,CProxy_WSLB>  CBase_WSLB;

extern void _registerWSLB(void);
#endif
